#include <stdio.h>
#include <stdlib.h>

int main()
{
    int n,h,i,j,s=0,desnagranica,levagranica,p=0;
    scanf("%d %d",&h,&n);
    int a[h+1][n+1];
    for(j=0;j<=n;j++)
        a[0][j]=1;
    for(i=1;i<=h;i++)
        for(j=1;j<=n;j++)
            scanf("%d",&a[i][j]);
    int b[h+1][n+1];// dodaj da je prvi red 1
    for(j=0;j<=n;j++)
        b[0][j]=1;
    for(i=1;i<=h;i++)
        for(j=1;j<=n;j++)
            b[i][j]=0;
    for(i=1;i<=h;i++)
    {
        for(j=1;j<=n;j++)
        {
            if(a[i][j]==1)
                b[i][j]=b[i][j]+b[i-1][j];
            else
            {
                levagranica=j;
                while(a[i][j]==0&&j<=n)
                {
                    s=s+b[i-1][j];
                    b[i][j]=0;
                    j++;
                }
                if(j==n+1)
                {
                    b[i][levagranica-1]=b[i][levagranica-1]+s;
                }
                else
                {
                    desnagranica=j;
                    if(s%2==0)
                    {
                        if(levagranica!=1)
                        {
                            b[i][levagranica-1]=b[i][levagranica-1]+s/2;
                            b[i][desnagranica]=b[i][desnagranica]+s/2+b[i-1][desnagranica];
                        }
                       else
                           b[i][desnagranica]=b[i][desnagranica]+s+b[i-1][desnagranica];
                    }
                    else
                    {
                        if(i%2==1)
                        {
                            if(levagranica!=1)
                        {
                            b[i][levagranica-1]=b[i][levagranica-1]+s/2+1;
                            b[i][desnagranica]=b[i][desnagranica]+s/2+b[i-1][desnagranica];
                        }
                        else
                           b[i][desnagranica]=b[i][desnagranica]+s+b[i-1][desnagranica];
                        }
                        else
                        {
                            if(levagranica!=1)
                        {
                            b[i][levagranica-1]=b[i][levagranica-1]+s/2;
                            b[i][desnagranica]=b[i][desnagranica]+s/2+1+b[i-1][desnagranica];
                        }
                        else
                           b[i][desnagranica]=b[i][desnagranica]+s+b[i-1][desnagranica];
                        }
                    }
                }
            }
            s=0;
        }
    }
    for(j=1;j<=n;j++)
    printf("%d ",b[h][j]);

    return 0;
}